searchData={"items":[{"type":"module","title":"AI","doc":"AI is a behavior module that defines the interface for interacting with\nOpenAI's API. It provides a common interface for the various OpenAI-powered\noperations used by the application.","ref":"AI.html"},{"type":"function","title":"AI.get_completion/4","doc":"","ref":"AI.html#get_completion/4"},{"type":"function","title":"AI.get_embeddings/2","doc":"Get embeddings for the given text. The text is split into chunks of 8192\ntokens to avoid exceeding the model's input limit. Returns a list of\nembeddings for each chunk.","ref":"AI.html#get_embeddings/2"},{"type":"function","title":"AI.get_embeddings!/2","doc":"Identical to `get_embeddings/2`, but raises an error if the request fails.","ref":"AI.html#get_embeddings!/2"},{"type":"function","title":"AI.new/0","doc":"Create a new AI instance. Instances share the same client connection.","ref":"AI.html#new/0"},{"type":"type","title":"AI.t/0","doc":"","ref":"AI.html#t:t/0"},{"type":"module","title":"AI.Accumulator","doc":"When file or other input to too large for the model's context window, this\nmodule may be used to process the file in chunks. It automatically modifies\nthe supplied agent prompt to include instructions for accumulating a response\nacross multiple chunks based on the `context` (max context window tokens)\nparameter supplied by the `model` parameter.\n\nNote that while this makes use of the `AI.Completion` module, it does NOT\nhave the same interface and cannot be used for long-running conversations, as\nit does not accept a list of messages as its input.","ref":"AI.Accumulator.html"},{"type":"type","title":"AI.Accumulator.error/0","doc":"","ref":"AI.Accumulator.html#t:error/0"},{"type":"function","title":"AI.Accumulator.get_response/2","doc":"","ref":"AI.Accumulator.html#get_response/2"},{"type":"type","title":"AI.Accumulator.response/0","doc":"","ref":"AI.Accumulator.html#t:response/0"},{"type":"type","title":"AI.Accumulator.success/0","doc":"","ref":"AI.Accumulator.html#t:success/0"},{"type":"behaviour","title":"AI.Agent","doc":"","ref":"AI.Agent.html"},{"type":"type","title":"AI.Agent.error/0","doc":"","ref":"AI.Agent.html#t:error/0"},{"type":"callback","title":"AI.Agent.get_response/2","doc":"","ref":"AI.Agent.html#c:get_response/2"},{"type":"type","title":"AI.Agent.response/0","doc":"","ref":"AI.Agent.html#t:response/0"},{"type":"module","title":"AI.Agent.Archivist","doc":"","ref":"AI.Agent.Archivist.html"},{"type":"module","title":"AI.Agent.CodeMapper","doc":"","ref":"AI.Agent.CodeMapper.html"},{"type":"module","title":"AI.Agent.FactChecker","doc":"","ref":"AI.Agent.FactChecker.html"},{"type":"module","title":"AI.Agent.FileInfo","doc":"","ref":"AI.Agent.FileInfo.html"},{"type":"module","title":"AI.Agent.FileSummary","doc":"This module provides an agent that summarizes files' contents in order to\ngenerate embeddings for the database and summaries for the user.","ref":"AI.Agent.FileSummary.html"},{"type":"module","title":"AI.Agent.NotesConsolidator","doc":"","ref":"AI.Agent.NotesConsolidator.html"},{"type":"type","title":"AI.Agent.NotesConsolidator.ai/0","doc":"","ref":"AI.Agent.NotesConsolidator.html#t:ai/0"},{"type":"type","title":"AI.Agent.NotesConsolidator.note/0","doc":"","ref":"AI.Agent.NotesConsolidator.html#t:note/0"},{"type":"module","title":"AI.Agent.Reason","doc":"This agent uses a combination of the reasoning features of the OpenAI o3-mini\nmodel as well as its own reasoning process to research and answer the input\nquestion.\n\nIt is able to use most of the tools available and will save notes for future\nuse before finalizing its response.","ref":"AI.Agent.Reason.html"},{"type":"module","title":"AI.Agent.Spelunker","doc":"","ref":"AI.Agent.Spelunker.html"},{"type":"module","title":"AI.Completion","doc":"This module sends a request to the model and handles the response. It is able\nto handle tool calls and responses.","ref":"AI.Completion.html"},{"type":"module","title":"Output options - AI.Completion","doc":"Output is controlled by the following mechanisms.\n\n1. `log_msgs` - log messages from the user and assistant as `info`\n2. `log_tool_calls` - log tool calls as `info` and tool call results as `debug`\n\n`LOGGER_LEVEL` must be set to `debug` to see the output of tool call results.","ref":"AI.Completion.html#module-output-options"},{"type":"function","title":"AI.Completion.get/2","doc":"","ref":"AI.Completion.html#get/2"},{"type":"function","title":"AI.Completion.get_completion/1","doc":"","ref":"AI.Completion.html#get_completion/1"},{"type":"function","title":"AI.Completion.handle_tool_call/2","doc":"","ref":"AI.Completion.html#handle_tool_call/2"},{"type":"function","title":"AI.Completion.new/2","doc":"","ref":"AI.Completion.html#new/2"},{"type":"function","title":"AI.Completion.new_from_conversation/3","doc":"","ref":"AI.Completion.html#new_from_conversation/3"},{"type":"type","title":"AI.Completion.response/0","doc":"","ref":"AI.Completion.html#t:response/0"},{"type":"type","title":"AI.Completion.t/0","doc":"","ref":"AI.Completion.html#t:t/0"},{"type":"function","title":"AI.Completion.tools_used/1","doc":"","ref":"AI.Completion.html#tools_used/1"},{"type":"module","title":"AI.Completion.Output","doc":"","ref":"AI.Completion.Output.html"},{"type":"function","title":"AI.Completion.Output.log_assistant_msg/2","doc":"","ref":"AI.Completion.Output.html#log_assistant_msg/2"},{"type":"function","title":"AI.Completion.Output.log_tool_call/2","doc":"","ref":"AI.Completion.Output.html#log_tool_call/2"},{"type":"function","title":"AI.Completion.Output.log_tool_call/3","doc":"","ref":"AI.Completion.Output.html#log_tool_call/3"},{"type":"function","title":"AI.Completion.Output.log_tool_call_error/3","doc":"","ref":"AI.Completion.Output.html#log_tool_call_error/3"},{"type":"function","title":"AI.Completion.Output.log_tool_call_result/2","doc":"","ref":"AI.Completion.Output.html#log_tool_call_result/2"},{"type":"function","title":"AI.Completion.Output.log_tool_call_result/3","doc":"","ref":"AI.Completion.Output.html#log_tool_call_result/3"},{"type":"function","title":"AI.Completion.Output.log_user_msg/2","doc":"","ref":"AI.Completion.Output.html#log_user_msg/2"},{"type":"function","title":"AI.Completion.Output.on_event/3","doc":"","ref":"AI.Completion.Output.html#on_event/3"},{"type":"function","title":"AI.Completion.Output.replay_conversation/1","doc":"Replays an earlier conversation identically to the original interaction,\nexcept that the final response is logged as a typical assistant message, so\nthat the conversation may be continued.","ref":"AI.Completion.Output.html#replay_conversation/1"},{"type":"function","title":"AI.Completion.Output.replay_conversation_as_output/1","doc":"Replaces the entire conversation, similarly to `replay_conversation/1`, but\nprints the final message to STDOUT, identically to the original interaction.\nThis is intended to be used when replaying the entire conversation to\nreplicate the original interaction, rather than for the sake of continuing\nthe conversation to refine output.","ref":"AI.Completion.Output.html#replay_conversation_as_output/1"},{"type":"module","title":"AI.Model","doc":"","ref":"AI.Model.html"},{"type":"function","title":"AI.Model.balanced/0","doc":"","ref":"AI.Model.html#balanced/0"},{"type":"function","title":"AI.Model.embeddings/0","doc":"","ref":"AI.Model.html#embeddings/0"},{"type":"function","title":"AI.Model.fast/0","doc":"","ref":"AI.Model.html#fast/0"},{"type":"function","title":"AI.Model.new/3","doc":"","ref":"AI.Model.html#new/3"},{"type":"type","title":"AI.Model.reasoning/0","doc":"","ref":"AI.Model.html#t:reasoning/0"},{"type":"function","title":"AI.Model.smart/0","doc":"","ref":"AI.Model.html#smart/0"},{"type":"type","title":"AI.Model.t/0","doc":"","ref":"AI.Model.html#t:t/0"},{"type":"module","title":"AI.OpenAI","doc":"This module provides functions to interact with the OpenAI API, including\ngetting embeddings and completions.","ref":"AI.OpenAI.html"},{"type":"function","title":"AI.OpenAI.get_completion/4","doc":"","ref":"AI.OpenAI.html#get_completion/4"},{"type":"function","title":"AI.OpenAI.get_embedding/3","doc":"","ref":"AI.OpenAI.html#get_embedding/3"},{"type":"function","title":"AI.OpenAI.new/1","doc":"","ref":"AI.OpenAI.html#new/1"},{"type":"module","title":"AI.Splitter","doc":"This module is used to split a string into chunks by the number of tokens,\nwhile accounting for *other* data that might be going with it to the API\nendpoint with the limited token count.\n\nFor example, the search entry agent may be processing a large file, one that\nmust be split into 3 slices just to fit it into the payload of an API call.\nIn order to retain context between chunks, the agent essentially _reduces_\nover the file, keeping track of information in the previous chunks to\ngenerate a final summary. Doing that means that we need to not only split the\nfile by the number of tokens in each slice, but also keep some space for the\nbespoke data that will be added to the payload as the agent's \"accumulator\".","ref":"AI.Splitter.html"},{"type":"function","title":"AI.Splitter.new/2","doc":"","ref":"AI.Splitter.html#new/2"},{"type":"function","title":"AI.Splitter.next_chunk/2","doc":"","ref":"AI.Splitter.html#next_chunk/2"},{"type":"behaviour","title":"AI.Tokenizer","doc":"> Oh yeah? I'm gonna make my own tokenizer, with blackjack and hookers!\n                                                    -- ~Bender~ ChatGPT\n\nThe only tokenizer modules available for elixir when this was written are\neither older and don't correctly count for OpenAI's newer models\n(Gpt3Tokenizer) or can't be used in an escript because they require priv\naccess or OTP support beyond escript's abilities (Tokenizers).","ref":"AI.Tokenizer.html"},{"type":"function","title":"AI.Tokenizer.chunk/2","doc":"Splits a string into chunks of `model.context` tokens using the algorithm\ndefined for the specified model.","ref":"AI.Tokenizer.html#chunk/2"},{"type":"function","title":"AI.Tokenizer.decode/2","doc":"Decodes a list of token IDs into a text string using the algorithm defined\nfor the specified model.","ref":"AI.Tokenizer.html#decode/2"},{"type":"callback","title":"AI.Tokenizer.decode/2","doc":"","ref":"AI.Tokenizer.html#c:decode/2"},{"type":"function","title":"AI.Tokenizer.encode/2","doc":"Encodes a text string into a list of token IDs using the algorithm defined\nfor the specified model.","ref":"AI.Tokenizer.html#encode/2"},{"type":"callback","title":"AI.Tokenizer.encode/2","doc":"","ref":"AI.Tokenizer.html#c:encode/2"},{"type":"function","title":"AI.Tokenizer.impl/0","doc":"Returns the tokenizer implementation module currently in use. This is defined\nin the application config, under `fnord/tokenizer`, allowing it to be\noverridden for testing.","ref":"AI.Tokenizer.html#impl/0"},{"type":"module","title":"AI.Tokenizer.Default","doc":"Implements the default tokenizer behaviour for AI.Tokenizer.","ref":"AI.Tokenizer.Default.html"},{"type":"module","title":"AI.Tokenizer.Tokens_cl100k_base","doc":"This module implements the cl100k-base tokenizer model used by OpenAI's\n`text-embedding-3-large` model.","ref":"AI.Tokenizer.Tokens_cl100k_base.html"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_merges/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_merges/0"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_pattern/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_pattern/0"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_reverse_vocab/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_reverse_vocab/0"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_special_tokens/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_special_tokens/0"},{"type":"function","title":"AI.Tokenizer.Tokens_cl100k_base.get_vocab/0","doc":"","ref":"AI.Tokenizer.Tokens_cl100k_base.html#get_vocab/0"},{"type":"module","title":"AI.Tokenizer.Tokens_o200k_base","doc":"This module implements the o200k-base tokenizer model used by OpenAI's\n`gpt-4o` models.","ref":"AI.Tokenizer.Tokens_o200k_base.html"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_merges/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_merges/0"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_pattern/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_pattern/0"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_reverse_vocab/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_reverse_vocab/0"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_special_tokens/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_special_tokens/0"},{"type":"function","title":"AI.Tokenizer.Tokens_o200k_base.get_vocab/0","doc":"","ref":"AI.Tokenizer.Tokens_o200k_base.html#get_vocab/0"},{"type":"behaviour","title":"AI.Tools","doc":"This module defines the behaviour for tool calls. Defining a new tool\nrequires implementing the `spec/0` and `call/2` functions.\n\nThe `spec/0` function should return a map that describes the tool's\ncapabilities and arguments, using a map to represent the OpenAPI spec.\n\nThe `call/2` function generates the tool call response. It accepts the\nrequesting `AI.Completion`'s struct and a map derived from the parsed JSON\nprovided by the agent, containing the tool call arguments. Note that, because\nthe arguments are parsed from JSON, the keys will all be strings. Whether\nthose are converted to symbols is between the tool implementation and the\ncode it calls. What happens behind closed APIs is none of MY business.","ref":"AI.Tools.html"},{"type":"behaviour","title":"Skeleton Implementation - AI.Tools","doc":"```elixir\ndefmodule AI.Tools.MyNewTool do\n  @behaviour AI.Tools\n\n  @impl AI.Tools\n  def ui_note_on_request(_args) do\n    {\"Doing something\", \"This tool is doing something.\"}\n  end\n\n  @impl AI.Tools\n  def ui_note_on_result(_args, _result) do\n    {\"Did something\", \"This tool did something.\"}\n  end\n\n  @impl AI.Tools\n  def read_args(args) do\n    {:ok, args}\n  end\n\n  @impl AI.Tools\n  def spec() do\n    %{\n      type: \"function\",\n      function: %{\n        name: \"something_tool\",\n        description: \"This tool does something.\",\n        strict: true,\n        parameters: %{\n          additionalProperties: false,\n          type: \"object\",\n          required: [\"thing\"],\n          properties: %{\n            thing: %{\n              type: \"string\",\n              description: \"The thing to do.\"\n            }\n          }\n        }\n      }\n    }\n  end\n\n  @impl AI.Tools\n  def call(_completion, args) do\n    {:ok, \"IMPLEMENT ME\"}\n  end\nend\n```","ref":"AI.Tools.html#module-skeleton-implementation"},{"type":"function","title":"AI.Tools.all_tools/1","doc":"","ref":"AI.Tools.html#all_tools/1"},{"type":"type","title":"AI.Tools.args_error/0","doc":"","ref":"AI.Tools.html#t:args_error/0"},{"type":"callback","title":"AI.Tools.call/2","doc":"Calls the tool with the provided arguments and returns the response as an :ok\ntuple.","ref":"AI.Tools.html#c:call/2"},{"type":"function","title":"AI.Tools.frobs/1","doc":"","ref":"AI.Tools.html#frobs/1"},{"type":"function","title":"AI.Tools.get_entry/1","doc":"","ref":"AI.Tools.html#get_entry/1"},{"type":"function","title":"AI.Tools.get_entry/2","doc":"","ref":"AI.Tools.html#get_entry/2"},{"type":"function","title":"AI.Tools.get_file_contents/1","doc":"","ref":"AI.Tools.html#get_file_contents/1"},{"type":"function","title":"AI.Tools.get_file_contents/2","doc":"","ref":"AI.Tools.html#get_file_contents/2"},{"type":"function","title":"AI.Tools.get_project/0","doc":"","ref":"AI.Tools.html#get_project/0"},{"type":"function","title":"AI.Tools.on_tool_request/3","doc":"","ref":"AI.Tools.html#on_tool_request/3"},{"type":"function","title":"AI.Tools.on_tool_result/4","doc":"","ref":"AI.Tools.html#on_tool_result/4"},{"type":"function","title":"AI.Tools.perform_tool_call/4","doc":"","ref":"AI.Tools.html#perform_tool_call/4"},{"type":"callback","title":"AI.Tools.read_args/1","doc":"Reads the arguments and returns a map of the arguments if they are valid.\nThis is used to validate args before the tool is called. The result is what\nis passed to `call/2`, `ui_note_on_request/1`, and `ui_note_on_result/2`.","ref":"AI.Tools.html#c:read_args/1"},{"type":"function","title":"AI.Tools.required_arg_error/1","doc":"","ref":"AI.Tools.html#required_arg_error/1"},{"type":"callback","title":"AI.Tools.spec/0","doc":"Returns the OpenAPI spec for the tool as an elixir map.","ref":"AI.Tools.html#c:spec/0"},{"type":"function","title":"AI.Tools.tool_module/2","doc":"","ref":"AI.Tools.html#tool_module/2"},{"type":"function","title":"AI.Tools.tool_spec/2","doc":"","ref":"AI.Tools.html#tool_spec/2"},{"type":"function","title":"AI.Tools.tool_spec!/2","doc":"","ref":"AI.Tools.html#tool_spec!/2"},{"type":"function","title":"AI.Tools.tools/0","doc":"","ref":"AI.Tools.html#tools/0"},{"type":"callback","title":"AI.Tools.ui_note_on_request/1","doc":"Return either a short string or a string tuple of label + detail to be\ndisplayed when the tool is called.","ref":"AI.Tools.html#c:ui_note_on_request/1"},{"type":"callback","title":"AI.Tools.ui_note_on_result/2","doc":"Return either a short string or a string tuple of label + detail to be\ndisplayed when the tool call is successful.","ref":"AI.Tools.html#c:ui_note_on_result/2"},{"type":"function","title":"AI.Tools.validate_required_args/3","doc":"","ref":"AI.Tools.html#validate_required_args/3"},{"type":"function","title":"AI.Tools.with_args/4","doc":"","ref":"AI.Tools.html#with_args/4"},{"type":"module","title":"AI.Tools.File.Contents","doc":"","ref":"AI.Tools.File.Contents.html"},{"type":"module","title":"AI.Tools.File.Info","doc":"","ref":"AI.Tools.File.Info.html"},{"type":"module","title":"AI.Tools.File.List","doc":"","ref":"AI.Tools.File.List.html"},{"type":"module","title":"AI.Tools.File.Outline","doc":"","ref":"AI.Tools.File.Outline.html"},{"type":"module","title":"AI.Tools.File.Search","doc":"","ref":"AI.Tools.File.Search.html"},{"type":"module","title":"AI.Tools.File.Spelunker","doc":"","ref":"AI.Tools.File.Spelunker.html"},{"type":"module","title":"AI.Tools.Git.DiffBranch","doc":"","ref":"AI.Tools.Git.DiffBranch.html"},{"type":"module","title":"AI.Tools.Git.Grep","doc":"","ref":"AI.Tools.Git.Grep.html"},{"type":"module","title":"AI.Tools.Git.ListBranches","doc":"","ref":"AI.Tools.Git.ListBranches.html"},{"type":"module","title":"AI.Tools.Git.Log","doc":"","ref":"AI.Tools.Git.Log.html"},{"type":"module","title":"AI.Tools.Git.Pickaxe","doc":"","ref":"AI.Tools.Git.Pickaxe.html"},{"type":"module","title":"AI.Tools.Git.Show","doc":"","ref":"AI.Tools.Git.Show.html"},{"type":"module","title":"AI.Tools.Notes.Save","doc":"","ref":"AI.Tools.Notes.Save.html"},{"type":"module","title":"AI.Util","doc":"","ref":"AI.Util.html"},{"type":"function","title":"AI.Util.assistant_msg/1","doc":"Creates an assistant message object, representing the assistant's response.","ref":"AI.Util.html#assistant_msg/1"},{"type":"function","title":"AI.Util.assistant_tool_msg/3","doc":"This is the tool call message, which must come immediately before the\n`tool_msg/3` message with the same `tool_call_id` (`id`).","ref":"AI.Util.html#assistant_tool_msg/3"},{"type":"function","title":"AI.Util.cosine_similarity/2","doc":"","ref":"AI.Util.html#cosine_similarity/2"},{"type":"function","title":"AI.Util.note_format_prompt/0","doc":"","ref":"AI.Util.html#note_format_prompt/0"},{"type":"function","title":"AI.Util.parse_topic_list/1","doc":"","ref":"AI.Util.html#parse_topic_list/1"},{"type":"function","title":"AI.Util.research_transcript/1","doc":"Builds a \"transcript\" of the research process by converting the messages into\ntext. This is most commonly used to generate a transcript of the research\nperformed in a conversation for various agents and tool calls.","ref":"AI.Util.html#research_transcript/1"},{"type":"function","title":"AI.Util.system_msg/1","doc":"Creates a system message object, used to define the assistant's behavior for\nthe conversation.","ref":"AI.Util.html#system_msg/1"},{"type":"function","title":"AI.Util.tool_msg/3","doc":"This is the tool outputs message, which must come immediately after the\n`assistant_tool_msg/3` message with the same `tool_call_id` (`id`).","ref":"AI.Util.html#tool_msg/3"},{"type":"function","title":"AI.Util.user_msg/1","doc":"Creates a user message object, representing the user's input prompt.","ref":"AI.Util.html#user_msg/1"},{"type":"function","title":"AI.Util.user_query/1","doc":"Extracts the user's *most recent* query from the conversation messages.","ref":"AI.Util.html#user_query/1"},{"type":"function","title":"AI.Util.validate_notes_string/1","doc":"","ref":"AI.Util.html#validate_notes_string/1"},{"type":"behaviour","title":"Cmd","doc":"","ref":"Cmd.html"},{"type":"function","title":"Cmd.default_workers/0","doc":"","ref":"Cmd.html#default_workers/0"},{"type":"callback","title":"Cmd.run/3","doc":"","ref":"Cmd.html#c:run/3"},{"type":"callback","title":"Cmd.spec/0","doc":"","ref":"Cmd.html#c:spec/0"},{"type":"module","title":"Cmd.Ask","doc":"","ref":"Cmd.Ask.html"},{"type":"module","title":"Cmd.Config","doc":"","ref":"Cmd.Config.html"},{"type":"module","title":"Cmd.Conversations","doc":"","ref":"Cmd.Conversations.html"},{"type":"module","title":"Cmd.Defrag","doc":"","ref":"Cmd.Defrag.html"},{"type":"type","title":"Cmd.Defrag.note/0","doc":"","ref":"Cmd.Defrag.html#t:note/0"},{"type":"module","title":"Cmd.Files","doc":"","ref":"Cmd.Files.html"},{"type":"module","title":"Cmd.Frobs","doc":"","ref":"Cmd.Frobs.html"},{"type":"module","title":"Cmd.Index","doc":"","ref":"Cmd.Index.html"},{"type":"function","title":"Cmd.Index.new/1","doc":"","ref":"Cmd.Index.html#new/1"},{"type":"function","title":"Cmd.Index.perform_task/1","doc":"","ref":"Cmd.Index.html#perform_task/1"},{"type":"module","title":"Cmd.Index.Embeddings","doc":"","ref":"Cmd.Index.Embeddings.html"},{"type":"function","title":"Cmd.Index.Embeddings.index_project/1","doc":"","ref":"Cmd.Index.Embeddings.html#index_project/1"},{"type":"module","title":"Cmd.Notes","doc":"","ref":"Cmd.Notes.html"},{"type":"module","title":"Cmd.Projects","doc":"","ref":"Cmd.Projects.html"},{"type":"module","title":"Cmd.Replay","doc":"","ref":"Cmd.Replay.html"},{"type":"module","title":"Cmd.Search","doc":"","ref":"Cmd.Search.html"},{"type":"module","title":"Cmd.Summary","doc":"","ref":"Cmd.Summary.html"},{"type":"module","title":"Cmd.Tool","doc":"","ref":"Cmd.Tool.html"},{"type":"module","title":"Cmd.Torch","doc":"","ref":"Cmd.Torch.html"},{"type":"function","title":"Cmd.Torch.run/3","doc":"Permanently deletes the project from the store.","ref":"Cmd.Torch.html#run/3"},{"type":"module","title":"Cmd.Upgrade","doc":"","ref":"Cmd.Upgrade.html"},{"type":"module","title":"Fnord","doc":"Fnord is a code search tool that uses OpenAI's embeddings API to index and\nsearch code files.","ref":"Fnord.html"},{"type":"function","title":"Fnord.configure_logger/0","doc":"","ref":"Fnord.html#configure_logger/0"},{"type":"function","title":"Fnord.main/1","doc":"Main entry point for the application. Parses command line arguments and\ndispatches to the appropriate subcommand.","ref":"Fnord.html#main/1"},{"type":"function","title":"Fnord.spec/0","doc":"","ref":"Fnord.html#spec/0"},{"type":"module","title":"Frobs","doc":"Frobs are external tool call integrations. They allow users to define\nexternal actions that can be executed by the LLM while researching the user's\nquery.\n\nFrobs are stored in `$HOME/.fnord/tools/$frob_name` and are composed of:\n- `registry.json`:  A JSON file that registers the frob for the user's projects\n- `spec.json`:      A JSON file that defines the tool call's calling semantics\n- `main`:           A script or binary that performs the action\n\nThe `registry.json` file contains the following fields:\n```json\n{\n  // When true, the frob is available to all projects and the \"projects\"\n  // field is ignored.\n  \"global\": true,\n\n  // An array of project names for which fnord should make the frob\n  // available. Superseded by the \"global\" field when set to true.\n  \"projects\": [\"my_project\", \"other_project\"]\n}\n```\n\nThe \"name\" field in `spec.json` is used to register the frob with the LLM.\nThis name must match the frob's directory name.\n\nIf desired, the user can add a lib/util/etc directory to hold any utility or\nhelper code to be used by `main`.\n\nFnord communicates run-time information to the frob via environment variables:\n- FNORD_PROJECT     # The name of the currently selected project\n- FNORD_CONFIG      # JSON object of project config\n- FNORD_ARGS_JSON   # JSON object of LLM-provided arguments","ref":"Frobs.html"},{"type":"function","title":"Frobs.create/1","doc":"","ref":"Frobs.html#create/1"},{"type":"function","title":"Frobs.create_tool_module/1","doc":"","ref":"Frobs.html#create_tool_module/1"},{"type":"function","title":"Frobs.list/1","doc":"","ref":"Frobs.html#list/1"},{"type":"function","title":"Frobs.load/1","doc":"","ref":"Frobs.html#load/1"},{"type":"function","title":"Frobs.perform_tool_call/2","doc":"","ref":"Frobs.html#perform_tool_call/2"},{"type":"module","title":"Git","doc":"Module for interacting with git.","ref":"Git.html"},{"type":"function","title":"Git.base_commit/2","doc":"","ref":"Git.html#base_commit/2"},{"type":"function","title":"Git.diff_branch/2","doc":"","ref":"Git.html#diff_branch/2"},{"type":"function","title":"Git.git_diff/1","doc":"","ref":"Git.html#git_diff/1"},{"type":"function","title":"Git.git_log/1","doc":"","ref":"Git.html#git_log/1"},{"type":"function","title":"Git.git_root/0","doc":"","ref":"Git.html#git_root/0"},{"type":"function","title":"Git.grep/2","doc":"","ref":"Git.html#grep/2"},{"type":"function","title":"Git.ignored_dirs/0","doc":"","ref":"Git.html#ignored_dirs/0"},{"type":"function","title":"Git.ignored_dirs/1","doc":"","ref":"Git.html#ignored_dirs/1"},{"type":"function","title":"Git.ignored_files/0","doc":"","ref":"Git.html#ignored_files/0"},{"type":"function","title":"Git.ignored_files/1","doc":"","ref":"Git.html#ignored_files/1"},{"type":"function","title":"Git.is_git_repo?/0","doc":"","ref":"Git.html#is_git_repo?/0"},{"type":"function","title":"Git.is_git_repo?/1","doc":"","ref":"Git.html#is_git_repo?/1"},{"type":"function","title":"Git.is_ignored?/1","doc":"","ref":"Git.html#is_ignored?/1"},{"type":"function","title":"Git.is_ignored?/2","doc":"","ref":"Git.html#is_ignored?/2"},{"type":"function","title":"Git.list_branches/0","doc":"","ref":"Git.html#list_branches/0"},{"type":"function","title":"Git.pickaxe_regex/1","doc":"","ref":"Git.html#pickaxe_regex/1"},{"type":"function","title":"Git.show/1","doc":"","ref":"Git.html#show/1"},{"type":"function","title":"Git.show/2","doc":"","ref":"Git.html#show/2"},{"type":"module","title":"Http","doc":"","ref":"Http.html"},{"type":"function","title":"Http.post_json/4","doc":"","ref":"Http.html#post_json/4"},{"type":"behaviour","title":"Indexer","doc":"This behaviour wraps the AI-powered operations used by `Cmd.Index` to allow\noverrides for testing. See `impl/0`.","ref":"Indexer.html"},{"type":"type","title":"Indexer.completion/0","doc":"","ref":"Indexer.html#t:completion/0"},{"type":"type","title":"Indexer.embeddings/0","doc":"","ref":"Indexer.html#t:embeddings/0"},{"type":"type","title":"Indexer.error/0","doc":"","ref":"Indexer.html#t:error/0"},{"type":"type","title":"Indexer.file_content/0","doc":"","ref":"Indexer.html#t:file_content/0"},{"type":"type","title":"Indexer.file_path/0","doc":"","ref":"Indexer.html#t:file_path/0"},{"type":"callback","title":"Indexer.get_embeddings/2","doc":"","ref":"Indexer.html#c:get_embeddings/2"},{"type":"callback","title":"Indexer.get_outline/3","doc":"","ref":"Indexer.html#c:get_outline/3"},{"type":"callback","title":"Indexer.get_summary/3","doc":"","ref":"Indexer.html#c:get_summary/3"},{"type":"function","title":"Indexer.impl/0","doc":"Returns the current indexer module. This can be overridden by config for unit\ntesting. See `test/test_helper.exs`.","ref":"Indexer.html#impl/0"},{"type":"type","title":"Indexer.indexer/0","doc":"","ref":"Indexer.html#t:indexer/0"},{"type":"callback","title":"Indexer.new/0","doc":"","ref":"Indexer.html#c:new/0"},{"type":"module","title":"Once","doc":"","ref":"Once.html"},{"type":"function","title":"Once.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Once.html#child_spec/1"},{"type":"function","title":"Once.init/1","doc":"","ref":"Once.html#init/1"},{"type":"function","title":"Once.start_link/1","doc":"","ref":"Once.html#start_link/1"},{"type":"function","title":"Once.warn/1","doc":"","ref":"Once.html#warn/1"},{"type":"module","title":"Search","doc":"","ref":"Search.html"},{"type":"function","title":"Search.get_results/1","doc":"","ref":"Search.html#get_results/1"},{"type":"function","title":"Search.new/1","doc":"Creates a new `Search` struct with the given options.","ref":"Search.html#new/1"},{"type":"module","title":"Settings","doc":"","ref":"Settings.html"},{"type":"function","title":"Settings.delete/2","doc":"Delete a value from the settings store.","ref":"Settings.html#delete/2"},{"type":"function","title":"Settings.get/3","doc":"Get a value from the settings store.","ref":"Settings.html#get/3"},{"type":"function","title":"Settings.get_project/1","doc":"","ref":"Settings.html#get_project/1"},{"type":"function","title":"Settings.get_root/1","doc":"","ref":"Settings.html#get_root/1"},{"type":"function","title":"Settings.get_selected_project!/0","doc":"Get the project specified with --project. If the project name is not set, an\nerror will be raised.","ref":"Settings.html#get_selected_project!/0"},{"type":"function","title":"Settings.home/0","doc":"Get the path to the store root directory.","ref":"Settings.html#home/0"},{"type":"function","title":"Settings.new/0","doc":"","ref":"Settings.html#new/0"},{"type":"function","title":"Settings.set/3","doc":"Set a value in the settings store.","ref":"Settings.html#set/3"},{"type":"function","title":"Settings.set_project/2","doc":"","ref":"Settings.html#set_project/2"},{"type":"function","title":"Settings.settings_file/0","doc":"Get the path to the settings file. If the file does not exist, it will be\ncreated.","ref":"Settings.html#settings_file/0"},{"type":"type","title":"Settings.t/0","doc":"","ref":"Settings.html#t:t/0"},{"type":"module","title":"Spinner","doc":"","ref":"Spinner.html"},{"type":"function","title":"Spinner.run/2","doc":"","ref":"Spinner.html#run/2"},{"type":"module","title":"Store","doc":"","ref":"Store.html"},{"type":"function","title":"Store.get_project/0","doc":"","ref":"Store.html#get_project/0"},{"type":"function","title":"Store.get_project/1","doc":"","ref":"Store.html#get_project/1"},{"type":"function","title":"Store.list_projects/0","doc":"","ref":"Store.html#list_projects/0"},{"type":"function","title":"Store.store_home/0","doc":"","ref":"Store.html#store_home/0"},{"type":"module","title":"Store.Project","doc":"","ref":"Store.Project.html"},{"type":"function","title":"Store.Project.conversations/1","doc":"","ref":"Store.Project.html#conversations/1"},{"type":"function","title":"Store.Project.create/1","doc":"","ref":"Store.Project.html#create/1"},{"type":"function","title":"Store.Project.delete/1","doc":"","ref":"Store.Project.html#delete/1"},{"type":"function","title":"Store.Project.delete_missing_files/1","doc":"","ref":"Store.Project.html#delete_missing_files/1"},{"type":"function","title":"Store.Project.exists_in_store?/1","doc":"","ref":"Store.Project.html#exists_in_store?/1"},{"type":"function","title":"Store.Project.expand_path/2","doc":"","ref":"Store.Project.html#expand_path/2"},{"type":"function","title":"Store.Project.find_entry/2","doc":"","ref":"Store.Project.html#find_entry/2"},{"type":"function","title":"Store.Project.find_file/2","doc":"","ref":"Store.Project.html#find_file/2"},{"type":"function","title":"Store.Project.find_path_in_source_root/2","doc":"","ref":"Store.Project.html#find_path_in_source_root/2"},{"type":"function","title":"Store.Project.new/2","doc":"","ref":"Store.Project.html#new/2"},{"type":"function","title":"Store.Project.notes/1","doc":"","ref":"Store.Project.html#notes/1"},{"type":"function","title":"Store.Project.relative_path/2","doc":"","ref":"Store.Project.html#relative_path/2"},{"type":"function","title":"Store.Project.reset_notes/1","doc":"","ref":"Store.Project.html#reset_notes/1"},{"type":"function","title":"Store.Project.save_settings/3","doc":"","ref":"Store.Project.html#save_settings/3"},{"type":"function","title":"Store.Project.search_notes/4","doc":"","ref":"Store.Project.html#search_notes/4"},{"type":"function","title":"Store.Project.source_files/1","doc":"","ref":"Store.Project.html#source_files/1"},{"type":"function","title":"Store.Project.stored_files/1","doc":"","ref":"Store.Project.html#stored_files/1"},{"type":"type","title":"Store.Project.t/0","doc":"","ref":"Store.Project.html#t:t/0"},{"type":"function","title":"Store.Project.torch/1","doc":"","ref":"Store.Project.html#torch/1"},{"type":"module","title":"Store.Project.Conversation","doc":"Conversations are stored per project in the project's store dir, under\n`converations/`. Each conversation is given a UUID identifier and stored as a\nJSON file with the keys:\n  - `messages`: a list of messages in the conversation\n  - `timestamp`: the time the conversation was last written to\n\nExisting conversations are retrieved by their UUID identifier.","ref":"Store.Project.Conversation.html"},{"type":"function","title":"Store.Project.Conversation.delete/1","doc":"Deletes the conversation from the store. If the conversation does not exist,\nreturns an error tuple.","ref":"Store.Project.Conversation.html#delete/1"},{"type":"function","title":"Store.Project.Conversation.exists?/1","doc":"Returns true if the conversation exists on disk, false otherwise.","ref":"Store.Project.Conversation.html#exists?/1"},{"type":"function","title":"Store.Project.Conversation.new/0","doc":"Create a new conversation with a new UUID identifier and the globally\nselected project.","ref":"Store.Project.Conversation.html#new/0"},{"type":"function","title":"Store.Project.Conversation.new/1","doc":"Create a new conversation from an existing UUID identifier and the globally\nselected project.","ref":"Store.Project.Conversation.html#new/1"},{"type":"function","title":"Store.Project.Conversation.new/2","doc":"Create a new conversation from an existing UUID identifier and an explicitly\nspecified project.","ref":"Store.Project.Conversation.html#new/2"},{"type":"function","title":"Store.Project.Conversation.question/1","doc":"Returns the user's prompting message in the conversation. This is considered\nto be the first \"user\" role message in the conversation.","ref":"Store.Project.Conversation.html#question/1"},{"type":"function","title":"Store.Project.Conversation.read/1","doc":"Reads the conversation from the store. Returns a tuple with the timestamp and\nthe messages in the conversation.","ref":"Store.Project.Conversation.html#read/1"},{"type":"type","title":"Store.Project.Conversation.t/0","doc":"","ref":"Store.Project.Conversation.html#t:t/0"},{"type":"function","title":"Store.Project.Conversation.timestamp/1","doc":"Returns the timestamp of the conversation. If the conversation has not yet\nbeen saved to the store, returns 0.","ref":"Store.Project.Conversation.html#timestamp/1"},{"type":"function","title":"Store.Project.Conversation.write/2","doc":"Saves the conversation in the store. The conversation's timestamp is updated\nto the current time.","ref":"Store.Project.Conversation.html#write/2"},{"type":"module","title":"Store.Project.Entry","doc":"","ref":"Store.Project.Entry.html"},{"type":"function","title":"Store.Project.Entry.create/1","doc":"","ref":"Store.Project.Entry.html#create/1"},{"type":"function","title":"Store.Project.Entry.delete/1","doc":"","ref":"Store.Project.Entry.html#delete/1"},{"type":"function","title":"Store.Project.Entry.embeddings_file_paths/1","doc":"","ref":"Store.Project.Entry.html#embeddings_file_paths/1"},{"type":"function","title":"Store.Project.Entry.exists_in_store?/1","doc":"","ref":"Store.Project.Entry.html#exists_in_store?/1"},{"type":"function","title":"Store.Project.Entry.has_embeddings?/1","doc":"","ref":"Store.Project.Entry.html#has_embeddings?/1"},{"type":"function","title":"Store.Project.Entry.has_metadata?/1","doc":"","ref":"Store.Project.Entry.html#has_metadata?/1"},{"type":"function","title":"Store.Project.Entry.has_outline?/1","doc":"","ref":"Store.Project.Entry.html#has_outline?/1"},{"type":"function","title":"Store.Project.Entry.has_summary?/1","doc":"","ref":"Store.Project.Entry.html#has_summary?/1"},{"type":"function","title":"Store.Project.Entry.hash_is_current?/1","doc":"","ref":"Store.Project.Entry.html#hash_is_current?/1"},{"type":"function","title":"Store.Project.Entry.is_incomplete?/1","doc":"","ref":"Store.Project.Entry.html#is_incomplete?/1"},{"type":"function","title":"Store.Project.Entry.is_stale?/1","doc":"","ref":"Store.Project.Entry.html#is_stale?/1"},{"type":"function","title":"Store.Project.Entry.metadata_file_path/1","doc":"","ref":"Store.Project.Entry.html#metadata_file_path/1"},{"type":"function","title":"Store.Project.Entry.new_from_entry_path/2","doc":"","ref":"Store.Project.Entry.html#new_from_entry_path/2"},{"type":"function","title":"Store.Project.Entry.new_from_file_path/2","doc":"","ref":"Store.Project.Entry.html#new_from_file_path/2"},{"type":"function","title":"Store.Project.Entry.outline_file_path/1","doc":"","ref":"Store.Project.Entry.html#outline_file_path/1"},{"type":"function","title":"Store.Project.Entry.read/1","doc":"","ref":"Store.Project.Entry.html#read/1"},{"type":"function","title":"Store.Project.Entry.read_embeddings/1","doc":"","ref":"Store.Project.Entry.html#read_embeddings/1"},{"type":"function","title":"Store.Project.Entry.read_metadata/1","doc":"","ref":"Store.Project.Entry.html#read_metadata/1"},{"type":"function","title":"Store.Project.Entry.read_outline/1","doc":"","ref":"Store.Project.Entry.html#read_outline/1"},{"type":"function","title":"Store.Project.Entry.read_source_file/1","doc":"","ref":"Store.Project.Entry.html#read_source_file/1"},{"type":"function","title":"Store.Project.Entry.read_summary/1","doc":"","ref":"Store.Project.Entry.html#read_summary/1"},{"type":"function","title":"Store.Project.Entry.save/4","doc":"","ref":"Store.Project.Entry.html#save/4"},{"type":"function","title":"Store.Project.Entry.save_embeddings/2","doc":"","ref":"Store.Project.Entry.html#save_embeddings/2"},{"type":"function","title":"Store.Project.Entry.save_metadata/1","doc":"","ref":"Store.Project.Entry.html#save_metadata/1"},{"type":"function","title":"Store.Project.Entry.save_outline/2","doc":"","ref":"Store.Project.Entry.html#save_outline/2"},{"type":"function","title":"Store.Project.Entry.save_summary/2","doc":"","ref":"Store.Project.Entry.html#save_summary/2"},{"type":"function","title":"Store.Project.Entry.summary_file_path/1","doc":"","ref":"Store.Project.Entry.html#summary_file_path/1"},{"type":"type","title":"Store.Project.Entry.t/0","doc":"","ref":"Store.Project.Entry.html#t:t/0"},{"type":"module","title":"Store.Project.Entry.Embeddings","doc":"","ref":"Store.Project.Entry.Embeddings.html"},{"type":"module","title":"Store.Project.Entry.Metadata","doc":"","ref":"Store.Project.Entry.Metadata.html"},{"type":"module","title":"Store.Project.Entry.Outline","doc":"","ref":"Store.Project.Entry.Outline.html"},{"type":"module","title":"Store.Project.Entry.Summary","doc":"","ref":"Store.Project.Entry.Summary.html"},{"type":"behaviour","title":"Store.Project.EntryFile","doc":"","ref":"Store.Project.EntryFile.html"},{"type":"callback","title":"Store.Project.EntryFile.exists?/1","doc":"","ref":"Store.Project.EntryFile.html#c:exists?/1"},{"type":"callback","title":"Store.Project.EntryFile.new/2","doc":"","ref":"Store.Project.EntryFile.html#c:new/2"},{"type":"callback","title":"Store.Project.EntryFile.read/1","doc":"","ref":"Store.Project.EntryFile.html#c:read/1"},{"type":"callback","title":"Store.Project.EntryFile.store_path/1","doc":"","ref":"Store.Project.EntryFile.html#c:store_path/1"},{"type":"callback","title":"Store.Project.EntryFile.write/2","doc":"","ref":"Store.Project.EntryFile.html#c:write/2"},{"type":"module","title":"Store.Project.Note","doc":"","ref":"Store.Project.Note.html"},{"type":"function","title":"Store.Project.Note.exists?/1","doc":"","ref":"Store.Project.Note.html#exists?/1"},{"type":"function","title":"Store.Project.Note.is_valid_format?/1","doc":"","ref":"Store.Project.Note.html#is_valid_format?/1"},{"type":"function","title":"Store.Project.Note.new/1","doc":"","ref":"Store.Project.Note.html#new/1"},{"type":"function","title":"Store.Project.Note.new/2","doc":"","ref":"Store.Project.Note.html#new/2"},{"type":"function","title":"Store.Project.Note.parse/1","doc":"","ref":"Store.Project.Note.html#parse/1"},{"type":"function","title":"Store.Project.Note.parse_string/1","doc":"","ref":"Store.Project.Note.html#parse_string/1"},{"type":"function","title":"Store.Project.Note.read/1","doc":"","ref":"Store.Project.Note.html#read/1"},{"type":"function","title":"Store.Project.Note.read_embeddings/1","doc":"","ref":"Store.Project.Note.html#read_embeddings/1"},{"type":"function","title":"Store.Project.Note.read_note/1","doc":"","ref":"Store.Project.Note.html#read_note/1"},{"type":"type","title":"Store.Project.Note.t/0","doc":"","ref":"Store.Project.Note.html#t:t/0"},{"type":"function","title":"Store.Project.Note.write/2","doc":"","ref":"Store.Project.Note.html#write/2"},{"type":"module","title":"Store.Project.NoteParser","doc":"","ref":"Store.Project.NoteParser.html"},{"type":"function","title":"Store.Project.NoteParser.parse/1","doc":"","ref":"Store.Project.NoteParser.html#parse/1"},{"type":"module","title":"Timed","doc":"","ref":"Timed.html"},{"type":"function","title":"Timed.timed/2","doc":"","ref":"Timed.html#timed/2"},{"type":"module","title":"UI","doc":"","ref":"UI.html"},{"type":"function","title":"UI.async_stream/4","doc":"","ref":"UI.html#async_stream/4"},{"type":"function","title":"UI.begin_step/2","doc":"","ref":"UI.html#begin_step/2"},{"type":"function","title":"UI.confirm/1","doc":"","ref":"UI.html#confirm/1"},{"type":"function","title":"UI.confirm/2","doc":"","ref":"UI.html#confirm/2"},{"type":"function","title":"UI.debug/1","doc":"","ref":"UI.html#debug/1"},{"type":"function","title":"UI.debug/2","doc":"","ref":"UI.html#debug/2"},{"type":"function","title":"UI.end_step/2","doc":"","ref":"UI.html#end_step/2"},{"type":"function","title":"UI.error/1","doc":"","ref":"UI.html#error/1"},{"type":"function","title":"UI.error/2","doc":"","ref":"UI.html#error/2"},{"type":"function","title":"UI.flush/0","doc":"","ref":"UI.html#flush/0"},{"type":"function","title":"UI.info/1","doc":"","ref":"UI.html#info/1"},{"type":"function","title":"UI.info/2","doc":"","ref":"UI.html#info/2"},{"type":"function","title":"UI.printf_debug/1","doc":"","ref":"UI.html#printf_debug/1"},{"type":"function","title":"UI.progress_bar_start/3","doc":"","ref":"UI.html#progress_bar_start/3"},{"type":"function","title":"UI.progress_bar_update/1","doc":"","ref":"UI.html#progress_bar_update/1"},{"type":"function","title":"UI.quiet?/0","doc":"","ref":"UI.html#quiet?/0"},{"type":"function","title":"UI.report_step/1","doc":"","ref":"UI.html#report_step/1"},{"type":"function","title":"UI.report_step/2","doc":"","ref":"UI.html#report_step/2"},{"type":"function","title":"UI.spin/2","doc":"","ref":"UI.html#spin/2"},{"type":"function","title":"UI.warn/1","doc":"","ref":"UI.html#warn/1"},{"type":"function","title":"UI.warn/2","doc":"","ref":"UI.html#warn/2"},{"type":"module","title":"Util","doc":"","ref":"Util.html"},{"type":"function","title":"Util.async_filter/2","doc":"","ref":"Util.html#async_filter/2"},{"type":"function","title":"Util.async_stream/3","doc":"Convenience wrapper for `Task.async_stream/3` with the default optiosn for\nconcurrency and timeout set to `Application.get_env(:fnord, :workers)` and\n`:infinity`, respectively.","ref":"Util.html#async_stream/3"},{"type":"function","title":"Util.get_latest_version/0","doc":"","ref":"Util.html#get_latest_version/0"},{"type":"function","title":"Util.get_running_version/0","doc":"","ref":"Util.html#get_running_version/0"},{"type":"function","title":"Util.string_keys_to_atoms/1","doc":"Converts all string keys in a map to atoms, recursively.","ref":"Util.html#string_keys_to_atoms/1"},{"type":"extras","title":"Fnord","doc":"# Fnord\n\n[![Tests | Dialyzer](https://github.com/sysread/fnord/actions/workflows/run-tests.yml/badge.svg)](https://github.com/sysread/fnord/actions/workflows/run-tests.yml)\n\n- [Description](#description)\n- [Features](#features)\n- [Installation](#installation)\n- [Getting Started](#getting-started)\n- [Tool usage](#tool-usage)\n- [User integrations](#user-integrations)\n- [Copyright and License](#copyright-and-license)","ref":"readme.html"},{"type":"extras","title":"Description - Fnord","doc":"`fnord` is a command line tool that uses multiple LLM-powered agents and tools to provide a conversational interface to your codebase, notes, and other (non-binary) files.\n\nIt can be used to generate on-demand tutorials, playbooks, and documentation for your project, as well as to search for examples, explanations, and solutions to problems in your codebase.","ref":"readme.html#description"},{"type":"extras","title":"Why `fnord`? - Fnord","doc":"AI-powered tools are limited by to the data built into their training data. **RAG (Retrieval-Augmented Generation)** using tool calls can supplement the training data with information, such as your code base, to provide more accurate and relevant answers to your questions.\n\nBut even with RAG, the AI still runs up against the **context window**. This is the conversational \"memory\" of the AI, often making use of an \"attention mechanism\" to keep it focused on the current instructions, but causing it to lose track of details earlier in the conversation.\n\nIf you've ever pasted multiple files into ChatGPT or worked with it iteratively on a piece of coce, you've probably seen this in action. It may forget constraints you defined earlier in the conversation or hallucinate entities and functions that don't exist in any of the files you've shown it.\n\n`fnord` attempts to mitigate this will cleverly designed tool calls that allow the LLM to ask _other_ agents to perform tasks on its behalf. For example, it can generate a prompt to ask another agent to read through a file and retrieve specific details it needs, like a single function definition, the declaration of an interface, or whether a specific functions behaves in a certain way. This keeps the entire file out of the \"coordinating\" agent's context window while still allowing it to use the information in the file to generate a response. This allows `fnord` to conduct more complex research across many files and directories without losing track of the details it needs to provide accurate answers.","ref":"readme.html#why-fnord"},{"type":"extras","title":"Features - Fnord","doc":"- Semantic search\n- On-demand explanations, documentation, and tutorials\n- Git archaeology\n- Learns about your project(s) over time\n- Improves its research capabilities with each interaction\n- User integrations","ref":"readme.html#features"},{"type":"extras","title":"Installation - Fnord","doc":"Fnord is written in [Elixir](https://elixir-lang.org/) and is distributed as an `escript`.\n\n- **Install [elixir](https://elixir-lang.org/)**\n```bash\n# MacOS\nbrew install elixir\n\n# Debian-based\nsudo apt-get install elixir\n```\n\n- **Add the `escript` path to your shell's PATH**\n```bash\necho 'export PATH=\"$HOME/.mix/escripts:$PATH\"' >> ~/.bashrc\nsource ~/.bashrc\n```\n\n- **Install `fnord`**\n```bash\nmix escript.install github sysread/fnord\n```\n\n- **Set `OPENAI_API_KEY` in your shell environment**\n\nSet this in your shell environment to the OpenAI project key you wish to use for this tool.\nYou can create a new project and get a key [here](https://platform.openai.com/api-keys).\n\n\n- **Optional: Install a markdown viewer**\n\nMarkdown seems to be the language of choice for LLMs, so installing something like `glow` to pipe output to will make the output more readable.","ref":"readme.html#installation"},{"type":"extras","title":"Getting Started - Fnord","doc":"For the purposes of this guide, we will assume that `fnord` is installed and we are using it to interact with your project, `blarg`, which is located at `$HOME/dev/blarg`.","ref":"readme.html#getting-started"},{"type":"extras","title":"Index your project - Fnord","doc":"The first step is to index your project to make it searchable with `fnord`'s semantic search capabilities.\nThe first time you index your project may take a while, especially if there are a lot of files.\n`fnord` respects `.gitignore`, but you may also wish to exclude certain paths or globs from indexing (e.g., `-x 'node_modules'`).\n\n```bash\nfnord index --project blarg --dir $HOME/dev/blarg --exclude 'node_modules'\n```\n\nIf you cancel partway-through (for example, with `Ctrl-C`), you can resume indexing by running the same command again.\n\nYou must re-index your project to reflect changes in the code base, new files, deleted files, or to change the directory or exclusions. This is done by running the same command again.\n\n`fnord` stores its index in `$HOME/.fnord/$project`.","ref":"readme.html#index-your-project"},{"type":"extras","title":"Search your code base - Fnord","doc":"`fnord`'s semantic search is powered by embeddings generated by OpenAI's `text-embedding-3-large` model. The indexing process does a lot more than simply generated embeddigs for the contents of your files. It also generates summary documentation for each file as well as an index of all functions, entities, and symbols in each file to enhance semantic matches for common questions and symbols.\n\n```bash\nfnord search --project blarg --query \"callers of some_function\"\nfnord search --project blarg --query \"some_function definition\"\nfnord search --project blarg --query \"unit tests for some_function\"\n```\n\nThe summaries generated by the indexing process can also be included in the search results with the `--detail` flag.\n\n```bash\nfnord search --project blarg --query \"some_function declaration\" --detail | glow\n```\n\nIf you would like to see more information about a single file, you can use the `summary` command.\n\n```bash\nfnord summary --project blarg --file \"path/to/some_module.ext\" | glow\n```","ref":"readme.html#search-your-code-base"},{"type":"extras","title":"Generate answers on-demand - Fnord","doc":"`fnord` uses a combination of LLM-powered agents and tool calls to research your question within your project, including access to semantic search and git tools (read only!).\n\nAs it conducts its investigation, you will see some of the research steps reported back to you in real-time. These are printed to `STDERR` so they will not interfere with redirected output. If you wish to see more of this, set `LOGGER_LEVEL=debug` in your shell.\n\n```bash\nfnord ask --project blarg --question \"Where is the unit test for some_function?\"\nfnord ask --project blarg --question \"Find all callers of some_function\"\nfnord ask --project blarg --question \"Is there a function or method that does X?\"\nfnord ask --project blarg --question \"How do I add a new X implementation?\"\n```\n\nConversations (the transcript of messages between the LLM and the application) are saved for future reference and continuation. After each response, you will see a message like:\n```\nConversation saved with ID: c81928aa-6ab2-4346-9b2a-0edce6a639f0\n```\n\n#### Continuing a conversation\n\nIf desired, you can use that ID to continue the conversation with `--follow`.\n\n```bash\nfnord ask --project blarg --follow c81928aa-6ab2-4346-9b2a-0edce6a639f0 --question \"Is some_function still used?\"\n```\n\nList conversations with the `conversations` command.\n\n```bash\nfnord conversations --project blarg\n```\n\nPrune conversations older than a certain number of days with the `--prune` option.\n\n```bash\n# Prune conversations older than 30 days\nfnord conversations --project blarg --prune 30\n```\n\n#### Replaying a conversation\n\nYou can also `replay` a conversation, replicating the output of the original question, research steps, and response.\n\n```bash\nfnord replay --project blarg --conversation c81928aa-6ab2-4346-9b2a-0edce6a639f0 | glow\n```\n\nAs it learns more about your project, `fnord` will be able to answer more complex questions with less research.","ref":"readme.html#generate-answers-on-demand"},{"type":"extras","title":"Learning over time - Fnord","doc":"`fnord` learns about your project over time by saving facts and inferences it makes about the project while researching your questions. These facts and inferences are saved and made\nsearchable in the project's data in the `$HOME/.fnord` directory.\n\nYou can view the facts learned thus far, organized by topic, with the `notes` command.\n\n```bash\nfnord notes --project blarg | glow\n```\n\nOver time, these can become quite extensive, redundant, and stale over time as your code base evolves.\n\nConsolidate and fact-check the notes for your project with the `defrag` command.\n\n```bash\nfnord defrag --project blarg\n```\n\n`fnord` knows how to \"prime the pump\" for its learning process with an initial set of learnings.\n\n```bash\nfnord ask --project blarg --question \"Prime your research notes and report your findings\"\n```","ref":"readme.html#learning-over-time"},{"type":"extras","title":"Upgrades - Fnord","doc":"`fnord` is under active development and new features are added regularly. To upgrade to the latest version, simply run:\n\n```bash\nfnord upgrade\n```\n\nNote that this is just a shortcut for:\n\n```bash\nmix escript.install github sysread/fnord\n```","ref":"readme.html#upgrades"},{"type":"extras","title":"Other commands - Fnord","doc":"- **List projects:** `fnord projects`\n- **List files in a project:** `fnord files --project foo`\n- **Delete a project:** `fnord torch --project foo`","ref":"readme.html#other-commands"},{"type":"extras","title":"Tool usage - Fnord","doc":"All of the tool calls available to `fnord` are available for external use via the `tool` subcommand.\n\n```bash\n# List available tools\nfnord help tool\n\n# Get help for a specific tool\nfnord tool --tool file_search_tool --help\n\n# Call the tool\nfnord tool --tool file_search_tool --project blarg --query \"some_function definition\"\nfnord tool --tool file_info_tool --project blarg --file \"path/to/some_module.ext\" --question \"What public functions are defined in this file?\"\n```","ref":"readme.html#tool-usage"},{"type":"extras","title":"User integrations - Fnord","doc":"Users can create their own integrations, called **frobs**, that `fnord` can use as a tool call while researching.\nJust like built-in tools, these are usable through the `fnord tool` subcommand.\n\n```bash\n# Create a new integration\nfnord frobs create --name my_frob\n\n# Validate the frob\nfnord frobs check --name my_frob\n\n# List frobs\nfnord frobs list\n\n# List frobs that are registered for a project\nfnord frobs list --project blarg\n```\n\nFrobs are stored in `$HOME/fnord/tools` and are comprised of the following files:\n- `my_frob/registry.json` - a JSON file that identifies the projects for which the frob is available\n- `my_frob/spec.json` - a JSON file describing the frob's calling semantics in [OpenAI's function spec format](https://platform.openai.com/docs/guides/function-calling?api-mode=responses#defining-functions)\n- `my_frob/main` - a script or binary that performs the requested task\n\n**Make your tool available to your projects:** edit the `registry.json` file created when you ran `fnord frobs create` to include the project name(s) for which you want the frob to be available.\n\n```json\n{\n  // When true, the frob is available to all projects and the \"projects\" field is ignored.\n  \"global\": true,\n\n  // An array of project names for which fnord should make the frob available. Superseded by the \"global\" field when set to true.\n  \"projects\": [\"blarg\", \"some_other_project\"]\n}\n```\n\n**Implementing the frob:** the `main` file is a script or binary that implements the frob. `fnord` passes information to the frob via shell environment variables:\n\n- `FNORD_PROJECT`: The name of the currently selected project\n- `FNORD_CONFIG`: The project configuration from `$HOME/.fnord/settings.json` as a single JSON object\n- `FNORD_ARGS_JSON`: JSON object of LLM-provided arguments\n\n**Testing your frob:** if you prefix your `fnord ask` query with `testing:`, you can ask the LLM to test your frob to confirm it is working as expected.\n\n```bash\nfnord ask -p blarg -q \"testing: please confirm that the 'my_frob' tool is available to you\"\nfnord ask -p blarg -q \"testing: please make a call to 'my_frob' with the arguments 'foo' and 'bar' and report the results\"\n```","ref":"readme.html#user-integrations"},{"type":"extras","title":"Copyright and License - Fnord","doc":"This software is copyright (c) 2025 by Jeff Ober.\n\nThis is free software; you can redistribute it and/or modify it under the MIT License.","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}